## ros-one-magic-enum 0.9.7-31jammy.20251121.2028

=== debian/changelog ===
ros-one-magic-enum (0.9.7-31jammy.20251121.2028) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:28:14 +0000

ros-one-magic-enum (0.9.7-0jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:28:14 -0000
