## ros-one-magic-enum 0.9.7-31noble.20251121.2030

=== debian/changelog ===
ros-one-magic-enum (0.9.7-31noble.20251121.2030) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:30:27 +0000

ros-one-magic-enum (0.9.7-0noble) noble; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Neargye <neargye@gmail.com>  Fri, 21 Nov 2025 20:30:27 -0000
