## ros-one-magic-enum 0.9.7-45jammy.20260228.2032

=== meson_options.txt ===
option(
    'hash',
    type : 'boolean',
    value : false,
    description : 'Do hashing at build time - longer build times, but O(1) string lookup'
)
