=== debian/changelog ===
ros-one-magic-enum (0.9.7-45jammy.20260228.2032) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Neargye <neargye@gmail.com>  Sat, 28 Feb 2026 20:32:27 +0000
